prueba/routes/web.php
<?php



Route::get('/', function () {
    
    return view('auth.login');
});

//LLama todas las funciones del controlador
Route::resource('clientes', 'ClientesController')->middleware('auth');

Auth::routes();

//llama la vista principal

Route::get('/Cliente/index', 'HomeController@index')->name('inicio');

//llama la vista y el metodo de guardar
Route::post('/clientes', 'ClientesController@store')->name('cliente.store')->middleware('auth');

//Llama las vistas del controlador
Route::get('/cliente', 'ClientesController@index');

//llama la vista y el metodo de actualizar
Route::post('/clientes/{id}/update', 'ClientesController@update')->name('cliente.update')->middleware('auth');

//llama los datos para el select anidado
Route::get('/departamentos/{id}', 'ClientesController@getDepartamentos');

//llama la vista y el metodo de eliminar

Route::get('clientes/{id}/destroy', [
    'uses'  => 'ClientesController@destroy',
    'as' => 'cliente.destroy',

])->middleware('auth');

//es una ruta para llamar la vista de la tabla 
Route::get('/home', [
    'uses'  => 'HomeController@index',
    'as' => 'cliente.index',
]);

//es una ruta para llamar la vista para registrar un nuevo cliente 


Route::get('/Registrar', [
    'uses'  => 'ClientesController@index',
    'as' => 'registrar',

])->middleware('auth');

prueba/app/Clientes.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Pais;
use App\User;
use App\Sexos;


class Clientes extends Model
{
    //En el modelo se hace referecia a las relaciones y artributos de la tabla en la base de datos

    protected $table = "clientes";

    protected $primaryKey = "idCliente";


    protected $fillable = ['nombreCliente', 'apellidoCliente', 'telefonoCliente', 'id_Paises', 'id_Departamento', 'id_Sexo'];

    public function paises()
    {
        return $this->belongsTo(Pais::class, 'id_Paises');
    }
  
    public function departaments()
    {
        return $this->belongsTo(departamentos::class, 'id_Departamento');
    }
    public function sexos(){
        return $this->belongsTo(Sexos::class,'id_Sexo');
    }
}

prueba/app/Http/Controllers/ClientesController.php
<?php

namespace App\Http\Controllers;


use App\Clientes;
use App\departamentos;
use App\Pais;

use App\Sexos;


use App\Http\Requests\ClienteStoreRequest;
use App\Http\Requests\ClienteUpdateRequest;
use Illuminate\Support\Facades\Auth;
use RealRashid\SweetAlert\Facades\Alert;

class ClientesController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    //En este metodo muetra lo que requiere la vista de la tabla de clientes haciendo llamado a las relaciones de los modelos y la base de datos.
    public function index()
    {
        $clientes = Clientes::orderBy('idCliente')->get();
        $clientes->each(function ($clientes) {
            $clientes->paises;
            $clientes->departaments;

            $clientes->sexos;
        });
        return view('home', compact('clientes'));   
    }


    public function create()
    {
        return view('Cliente.prueba');

        //   return view('Cliente.create', compact('paises'));
        //  return view('Cliente.create', compact('users'));

    }


    public function show(Clientes $clientes)
    {
        //
    }


    //Este es el metodo que me almacena los datos ingresados en la base datos, tambien me llama la alerta cuando se ha creado el nuevo cliente.

    public function store(ClienteStoreRequest $request)
    {

        if ($request == null) {

            alert()->error('Title', 'Lorem Lorem Lorem');
        } else {
            Clientes::create($request->all());
            return  redirect()->route('inicio')->with('success', ' El cliente fue registrado');
        }
    }

    //Este metodo me llama los datos que son requeridos para modificar un registro, haciendo el llamado a cada una de los modelos por el id de cada una de las tablas, retornandolos a la vista de editar
    public function edit($id)
    {

        $sexss = Sexos::all();

        $paisess = Pais::all();
        $clientes = Clientes::find($id);

        $idPaises = $clientes->id_Paises;
        $departamentoos = departamentos::where('id_Paises',  $idPaises)->get();

        $nombrePais = Pais::find($idPaises);

        $id_Departamento = $clientes->id_Departamento;
        $nombreDepartamento = departamentos::find($id_Departamento);

        $idSexo = $clientes->id_Sexo;
        $tiposSexo = Sexos::find($idSexo);




        return view('edit')
            ->with('clientes', $clientes)
            ->with('paisess', $paisess)
            ->with('nombrePais', $nombrePais)

            ->with('departamentoos', $departamentoos)
            ->with('nombreDepartamento', $nombreDepartamento)
            ->with('sexss', $sexss)
            ->with('tiposSexo', $tiposSexo)
            ->with('idPaises', $idPaises)
            ->with('idSexo', $idSexo)
            ->with('idDepartamento', $id_Departamento);
    }
    //Este ya es el metodo que hace la actualizacion de los datos en la base de datos, tambien mostrando un mensaje de que se han actualizado los datos

    public function update(ClienteUpdateRequest $request, $id)
    {
        $datosCliente = request()->except(['_token', '_method']);


        Clientes::where('idCliente', '=', $id)->update($datosCliente);

        $clientes = Clientes::findOrFail($id);

        return  redirect()->route('inicio', compact('clientes'))->with('success', ' El cliente fue actualizado');
    }


    //Este es metodo que me elimina los datos, requeriendo el id de la tabla de clientes, elimina todos los datos relacionados a ese id.
    public function destroy($id)
    {
        if (Auth::check()) {
            $clientes = Clientes::find($id);
            $clientes->delete();
            return redirect()->route('inicio')->with('success', ' El cliente fue elimindo');
        } else return Alert::error('Error Title', 'Error Message');
    }
    //Este es el metodo que me ejecuta la busqueda de departamentos mediante un select el cual esta relacionado a un pais por medio de un id.
    public function getDepartamentos($id)
    {
        $departamentos["departamento"] = departamentos::where('id_Paises', $id)->get();
        return Response()->json($departamentos, 200);
    }


    //
    /*public function getDepartamentos(Request $request)
    {
        if ($request->ajax()) {
            $departamentos = departamentos::where('id_Paises', $request->id_Paises)->get();
            foreach ($departamentos as $departamento) {
                $departamentosArray[$departamento->id_Departamento] = $departamento->nombre_departemento;
            }
            return response()->json($departamentosArray);
        }
    }*/
}

prueba/resources/views/Cliente/index.blade.php
@extends('layouts.app')

@section('content')
@inject('paises', 'App\Services\Paises')
@if (Route::has('login'))
<div class="container">

    @auth
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card ">
                <div class="card-header bg-info text-light text-center"> Clientes Regisrados</div>
                @if(session('flash'))
                <br>
                <div class="alert alert-success" role="alert">
                    <strong>Aviso:</strong>{{session('flash')}}
                    <button type="button" class="close" data-dismiss="alert" alert-lable="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                @endif
                @if(session('success_message'))
                <br>
                <div class="alert alert-success">
                    {{ session('success_message')}}

                </div>
                @endif
                @if(session('error_message'))
                <br>
                <div class="alert alert-success">
                    {{ session('success_message')}}

                </div>
                @endif

                <div class="card-body">
                    <div class="table-responsive">
                        <div class="float-center text-center">
                            <a href="{{ route('registrar') }}" class=" text-light">
                                <i style="font-size:30px; color:#17a2b8;" class="fa">&#xf234;<h6>Añadir nuevo cliente</h6> </i>
                            </a>

                        </div>


                        <table class="table table-striped table-bordered" id="table_id" class="display">
                            <thead class="thead-light">
                                <th class="table-info">ID</th>
                                <th class="table-info">Nombre </th>
                                <th class="table-info">Apellido </th>
                                <th class="table-info">Sexo </th>
                                <th class="table-info">Teléfono </th>

                                <th class="table-info">Pais</th>
                                <th class="table-info">Departamento</th>
                                <th class="table-info">Acciones </th>

                            </thead>
                            <tbody>
                                @foreach ($clientes ?? '' as $cliente)
                                <tr class="table-active">
                                    <td>{{$cliente->idCliente}}</td>
                                    <td>{{$cliente->nombreCliente}}</td>
                                    <td>{{$cliente->apellidoCliente}}</td>
                                    <td>{{$cliente->sexos->tipoSexo}}</td>
                                    <td>{{$cliente->telefonoCliente}}</td>

                                    <td>{{$cliente->paises->nombrePais}}</td>
                                    <td>{{$cliente->departaments->nombre_departemento}}</td>

                                    <td>
                                   @auth
                                        <a href="{{ route('cliente.destroy', $cliente->idCliente)}}" onclick="return confirm('Seguro que quieres eliminarlo?')"><i style="font-size:35px; color:red;" class="fa">&#xf1f8;</i></a>

                                        <a href="{{ route('clientes.edit', $cliente->idCliente)}}"> <i style="font-size:35px; color:#17a2b8;" class="fa">&#xf14b; </i></a>
                                    @endauth
                                    </td>

                                </tr>
                                @endforeach
                            </tbody>


                        </table>
                    </div>


                </div>
            </div>
        </div>
    </div>



</div>
@else
<h3 class="text-center">No tines acceso a esta pagina</h3>
@endauth

@endif
@endsection